/*!
 * docor
 * Copyright(c) 2018 Douglas Chen <dougpuob@gmail.com>
 * MIT Licensed
 */
'use strict';


module.exports = class ModuleBase {
    constructor() {
        this._astjson = null;
        this._pajsdoc = null;
        this._all_functions = []; // <FunctionObject>

        this._function = {
            public  : [], // <DocorFunction>
            private : [], // <DocorFunction>
            internal: []  // <DocorFunction>
        };

        this._data = {
            public : [], // <DocorVariable>
            private: []  // <DocorVariable>
        };

        this.absPath = '';
        this.Name = '';
        this.File = {
            Source: [], // <string>
            Header: []  // <string>
        };
    }

    get allFoundFunctions() {
        return this._all_functions;
    }

    get publicFunctions() {
        return this._function.public;
    }

    get privateFunctions() {
        return this._function.private;
    }

    get internalFunctions() {
        return this._function.internal;
    }

    get publicData() {
        return this._data.public;
    }

    get privateData() {
        return this._data.private;
    }
};
