#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <stdbool.h>
#include "dirmodule.h"

/**
 * @module      {Parts} `DIR_MODULE` Directory module
 * @namespace   RtLib.Dir
 * @author      dougpuob <dougpuob@gmail.com>
*/

//================================================================================
// Public functions
//================================================================================
/**
* @function    GetCwd
* @summary     Clone current working directory path string.
* @description Callers have to free the returning value with RtLib.Mem.Free() functiojn.
* @return      {char*}
* @author      dougpuob <dougpuob@gmail.com>
*/
static char *
GetCwd(
    void)
{
    return NULL;
}

/**
* @function    GetNextSibling
* @summary     Get next slibling file entry of the current file entry.
* @description None.
* @param       `pFileEntry` A pointer of FILE_ENTRY points to current file entry.
* @return      {FILE_ENTRY*}
* @author      dougpuob <dougpuob@gmail.com>
*/
static FILE_ENTRY *
GetNextSibling(
    IN FILE_ENTRY *const pFileEntry)
{
    return pFileEntry;
}

/**
* @function    FindFileFirst
* @summary     Find first file of specific input directory and return a handle.
* @description Callers have to close this handle with RtLib.Dir.FindFileClose().
* @param       `szPath`     C string to input directory pathname.
* @param       `pFileInfo`  A pointer of FILEINFO to retrieve file information.
* @return      {FIND_HANDLE}
* @author      dougpuob <dougpuob@gmail.com>
*/
static FIND_HANDLE
FindFileFirst(
    IN char *const szPath,
    OUT FILEINFO *const pFileInfo)
{
    FIND_HANDLE hRetHandle = NULL;
    szPath;
    pFileInfo;
    return hRetHandle;
}

/**
* @function    FindFileNext
* @summary     Find next file with the input handle.
* @description None.
* @param       `hFindHandle` A handle which is the returning value of RtLib.Dir.FindFileFirst().
* @param       `pFileInfo`   A pointer of FILEINFO to retrieve file information.
* @return      {bool}
* @author      dougpuob <dougpuob@gmail.com>
*/
static bool
FindFileNext(
    IN FIND_HANDLE const hFindHandle,
    OUT FILEINFO *const pFileInfo)
{
    hFindHandle;
    pFileInfo;
    return false;
}

/**
* @function    FindFileClose
* @summary     Close a find file handle.
* @description None.
* @param       `hFindHandle` A handle which opened by RtLib.Dir.FindFileFirst() function.
* @return      {bool}
* @author      dougpuob <dougpuob@gmail.com>
*/
static bool
FindFileClose(
    IN FIND_HANDLE const hFindHandle)
{
    hFindHandle;
    return false;
}

/**
* @function    ReadDir
* @summary     Remove parent directories from input path string.
* @description This function will modify original input string buffer.
* @param       `szPath`     C string to be converted.
* @param       `bRecursive` Explore sub-directories recursively.
* @return      {FILE_ENTRY*}
* @author      dougpuob <dougpuob@gmail.com>
*/
static const FILE_ENTRY *
ReadDir(
    IN char *const szPath,
    IN bool const bRecursive)
{
    const FILE_ENTRY *pFileEntry = NULL;
    szPath;
    bRecursive;
    return pFileEntry;
}

/**
* @function    FullPath
* @summary     Get full pathname of input current file entry.
* @description The input buffer will be resized if original is insufficient.
* @param       `pFileEntry`    A pointer of FILE_ENTRY points to current file entry.
* @param       `pFullPathname` A pointer of STRING_BUFFER to retrieve full path.
* @return      {bool}
* @author      dougpuob <dougpuob@gmail.com>
*/
static bool
FullPath(
    IN FILE_ENTRY *const pFileEntry,
    OUT STRING_BUFFER *const pFullPathname)
{
    pFileEntry;
    pFullPathname;
    return false;
}

/**
* @function    GetErrorFilePath
* @summary     None.
* @description None.
* @return      {char*}
* @author      dougpuob <dougpuob@gmail.com>
*/
static const char *
GetErrorFilePath(void)
{
    return NULL;
}

/**
* @function    IsExist
* @summary     Check whether the specific directory existing.
* @description None.
* @param       `szDir`  C string to the specific directory path.
* @return      {bool}
* @author      dougpuob <dougpuob@gmail.com>
*/
static bool
IsExist(
    IN char *const szDir)
{
    return false;
}

/**
* @function    Create
* @summary     Create direcotry.
* @description None.
* @param       `szDir`  C string to the specific directory path.
* @return      {bool}
* @author      dougpuob <dougpuob@gmail.com>
*/
static bool
Create(
    IN char *const szDir)
{
    szDir;
    return false;
}

/**
* @function    Delete
* @summary     Delete the specific direcotry.
* @description None.
* @param       `szDir`  C string to the specific directory path.
* @return      {bool}
* @author      dougpuob <dougpuob@gmail.com>
*/
static bool
Delete(
    IN char *const szDir)
{
    szDir;
    return false;
}
