/*!
 * docor
 * Copyright(c) 2018 Douglas Chen <dougpuob@gmail.com>
 * MIT Licensed
 */
'use strict';

const path   = require('path');
const assert = require('assert');

const { Docor,
        DocorSetting,
        DocorLibrary,
        DocorModule,
        DocorFunction,
        DocorParameter,
        DocorSubModule
        } = require('../index.js');

describe('docor class', function () {
    describe('- docor()', function () {
        it('should return true', function () {
            let docor = new Docor('test/docor.ini');
            assert.equal(true, null !== docor);
            assert.equal(true, null !== docor.libraryList);
            assert.equal(true, 1 === docor.libraryList.length);

            if (docor.libraryList && docor.libraryList.length > 0) {
                assert.equal(true, 'Sample Library' === docor.libraryList[0].Name);
                assert.equal(true, 'SampleLib'      === docor.libraryList[0].Namespace);
            }

        });
    });

    describe('- _callCastJson()', function () {
        it('should return true', function () {
            let docor = new Docor();
            let ast = docor._callCastJson('test/sample/dirmodule.c');
            assert.equal(true, null !== ast);
            assert.equal(true, null !== ast.Functions);
            assert.equal(true, ast.Functions.length > 0);
        });
    });

    describe('- _classify()', function () {
        it('should return true', function () {
            let docor = new Docor();
            let setting = new DocorSetting('test/docor.ini');

            const library_list = docor._classify(setting.libraryList);
            assert.equal(true, null !== library_list);
            assert.equal(true, null !== library_list.length > 0);
        });
    });

});
